CMSIS-NN: Neural Network Data Conversion Functions

| CMSIS-NN Version 1.1.0 CMSIS NN Software Library

- Main Page
- Usage and Description
- Reference

All Data Structures Namespaces Files Functions Variables Enumerations Enumerator Macros Groups Pages
Functions
Neural Network Data Conversion Functions

## Functions
void | arm_q7_to_q15_no_shift (const q7_t *pSrc, q15_t *pDst, uint32_t blockSize)
| Converts the elements of the Q7 vector to Q15 vector without left-shift. More...
void | arm_q7_to_q15_reordered_no_shift (const q7_t *pSrc, q15_t *pDst, uint32_t blockSize)
| Converts the elements of the Q7 vector to reordered Q15 vector without left-shift. More...

## Description

Perform data type conversion in-between neural network operations

## Function Documentation

void arm_q7_to_q15_no_shift | ( | const q7_t * | pSrc,
|  | q15_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | *pSrc | points to the Q7 input vector
  [out] | *pDst | points to the Q15 output vector
  [in] | blockSize | length of the input vector

Returns
  none.

Description:

The equation used for the conversion process is:

            pDst[n] = (q15_t) pSrc[n];   0 <= n < blockSize.

Referenced by arm_avepool_q7_HWC(), arm_convolve_HWC_q7_basic(), and arm_convolve_HWC_q7_basic_nonsquare().

void arm_q7_to_q15_reordered_no_shift | ( | const q7_t * | pSrc,
|  | q15_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | *pSrc | points to the Q7 input vector
  [out] | *pDst | points to the Q15 output vector
  [in] | blockSize | length of the input vector

Returns
  none.

This function does the q7 to q15 expansion with re-ordering

                             |   A1   |   A2   |   A3   |   A4   |

                              0      7 8     15 16    23 24    31

is converted into:

     |       A1       |       A3       |   and  |       A2       |       A4       |

      0             15 16            31          0             15 16            31

This looks strange but is natural considering how sign-extension is done at assembly level.

The expansion of other other oprand will follow the same rule so that the end results are the same.

The tail (i.e., last (N % 4) elements) will still be in original order.

Referenced by arm_convolve_1x1_HWC_q7_fast_nonsquare(), arm_convolve_HWC_q7_fast(), arm_convolve_HWC_q7_fast_nonsquare(), arm_fully_connected_q7(), and arm_fully_connected_q7_opt().